Skip to main content

blocks.validate method

Facts

DescriptionValidates blocks, messages, and views Block Kit JSON payloads.
Method Access
POST https://slack.com/api/blocks.validate
ScopesNo scopes required
Content types
application/x-www-form-urlencoded
application/json

Arguments

Optional arguments

blocksstringOptional

A JSON-encoded array of structured blocks. Provide exactly one of blocks, view, or message.

Example: [{"type": "section", "text": {"type": "plain_text", "text": "Hello world"}}]
messagestringOptional

A JSON-encoded message payload to validate. Provide exactly one of blocks, view, or message.

Example: {"blocks": [{"type": "section", "text": {"type": "plain_text", "text": "Hello world"}}]}
viewstringOptional

A JSON-encoded view payload to validate. Provide exactly one of blocks, view, or message.

Example: {"type": "modal", "title": {"type": "plain_text", "text": "My Modal"}, "blocks": [{"type": "section", "text": {"type": "plain_text", "text": "Hello"}}]}

Usage info

This method validates Block Kit JSON payloads against the Block Kit schema. You can validate standalone blocks arrays, complete message payloads, and full view payloads, but only one per API call.

Validation errors

When validation fails, the response includes an errors array. Each error contains:

FieldDescription
pointera JSON pointer path to the invalid element (e.g., /0/text/type)
codethe error code (e.g., failed_constraint)
messagea human-readable description of the issue
constraintdetails about what was expected

Response

Typical success response when the provided blocks pass validation.

{
"ok": true
}

Error response when blocks contain invalid elements. The errors array provides detailed constraint information with JSON pointer paths.

{
"ok": false,
"error": "invalid_blocks",
"errors": [
{
"code": "failed_constraint",
"message": "unsupported type: invalid",
"pointer": "/0/text/type",
"constraint": {
"type": "enum",
"expected": [
"plain_text",
"mrkdwn"
]
}
}
]
}

Error response when the request does not provide exactly one of blocks, view, or message.

{
"ok": false,
"error": "invalid_arguments",
"response_metadata": {
"messages": [
"must provide exactly one of `blocks`, `view`, or `message`"
]
}
}

Errors

This table lists the expected errors that this method could return. However, other errors can be returned in the case where the service is down or other unexpected factors affect processing. Callers should always check the value of the ok parameter in the response.

Error
Description
access_denied

Access to a resource specified in the request is denied.

accesslimited

Access to this method is limited on the current network

account_inactive

Authentication token is for a deleted user or workspace when using a bot token.

deprecated_endpoint

The endpoint has been deprecated.

ekm_access_denied

Administrators have suspended the ability to post a message.

enterprise_is_restricted

The method cannot be called from an Enterprise.

fatal_error

The server could not complete your operation(s) without encountering a catastrophic error. It's possible some aspect of the operation succeeded before the error was raised.

internal_error

The server could not complete your operation(s) without encountering an error, likely due to a transient issue on our end. It's possible some aspect of the operation succeeded before the error was raised.

invalid_arg_name

The method was passed an argument whose name falls outside the bounds of accepted or expected values. This includes very long names and names with non-alphanumeric characters other than _. If you get this error, it is typically an indication that you have made a very malformed API call.

invalid_arguments

The request arguments are invalid. Ensure you provide exactly one of blocks, view, or message, and that the value is valid JSON. Consult response_metadata.messages for details.

invalid_arguments

The method was called with invalid arguments.

invalid_array_arg

The method was passed an array as an argument. Please only input valid strings.

invalid_auth

Some aspect of authentication cannot be validated. Either the provided token is invalid or the request originates from an IP address disallowed from making the request.

invalid_blocks

The blocks array failed validation. The errors field contains a list of issues, each with a JSON pointer path to the invalid element, the constraint that failed, and the expected value.

invalid_charset

The method was called via a POST request, but the charset specified in the Content-Type header was invalid. Valid charset names are: utf-8 iso-8859-1.

invalid_form_data

The method was called via a POST request with Content-Type application/x-www-form-urlencoded or multipart/form-data, but the form data was either missing or syntactically invalid.

invalid_message

The message payload failed validation. The errors field contains a list of issues, each with a JSON pointer path to the invalid element, the constraint that failed, and the expected value.

invalid_post_type

The method was called via a POST request, but the specified Content-Type was invalid. Valid types are: application/json application/x-www-form-urlencoded multipart/form-data text/plain.

invalid_view

The view payload failed validation. The errors field contains a list of issues, each with a JSON pointer path to the invalid element, the constraint that failed, and the expected value.

method_deprecated

The method has been deprecated.

missing_post_type

The method was called via a POST request and included a data payload, but the request did not include a Content-Type header.

missing_scope

The token used is not granted the specific scope permissions required to complete this request.

no_permission

The workspace token used in this request does not have the permissions necessary to complete the request. Make sure your app is a member of the conversation it's attempting to post a message to.

not_allowed_token_type

The token type used in this request is not allowed.

not_authed

No authentication token provided.

org_login_required

The workspace is undergoing an enterprise migration and will not be available until migration is complete.

ratelimited

Too many requests. Reduce your request rate and retry after a brief wait.

ratelimited

The request has been ratelimited. Refer to the Retry-After header for when to retry the request.

request_timeout

The method was called via a POST request, but the POST data was either missing or truncated.

service_unavailable

The service is temporarily unavailable

team_access_not_granted

The token used is not granted the specific workspace access required to complete this request.

team_added_to_org

The workspace associated with your request is currently undergoing migration to an Enterprise Organization. Web API and other platform operations will be intermittently unavailable until the transition is complete.

token_expired

Authentication token has expired

token_revoked

Authentication token is for a deleted user or workspace or the app has been removed when using a user token.

two_factor_setup_required

Two factor setup is required.